//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "VKRechnungUnit.h"

#define STEUERFAKTOR 0.17

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TVKRechnung *VKRechnung;

//---------------------------------------------------------------------------
// Vorbereitungen - Hier Fllen der Combobox
//---------------------------------------------------------------------------
__fastcall TVKRechnung::TVKRechnung(TComponent* Owner)
        : TForm(Owner)
{
  Cb_GewinnProzent->Items->Add("10 %");
  Cb_GewinnProzent->Items->Add("20 %");
  Cb_GewinnProzent->Items->Add("30 %");
  Cb_GewinnProzent->Items->Add("40 %");
  Cb_GewinnProzent->Items->Add("50 %");
  Cb_GewinnProzent->Items->Add("60 %");
  Cb_GewinnProzent->Items->Add("70 %");
  Cb_GewinnProzent->Items->Add("80 %");
  Cb_GewinnProzent->Items->Add("90 %");
  Cb_GewinnProzent->Items->Add("100 %");
}

//---------------------------------------------------------------------------
// Hilfsfunktion
//---------------------------------------------------------------------------
void TVKRechnung::MyBerechnen (void)
{
   char       sBuffer[100]   = "";
   double     fFixkosten     = 0.0;
   double     fGewinn        = 0.0;
   double     fVkVorSteuern  = 0.0;
   double     fSteuern       = 0.0;
   double     fVerkaufspreis = 0.0;
   double     fEkpreis       = atof (E_EkPreis->Text.c_str());
   AnsiString sSelected      = Cb_GewinnProzent->Items->Strings[Cb_GewinnProzent->ItemIndex];
   double     fGewinnProzent = atof (sSelected.c_str());

   if (Ck_Sonderangebot->State == cbUnchecked)
   {
     fFixkosten     = fEkpreis * 0.7;
     fGewinn        = fEkpreis * (fGewinnProzent / 100);
     fVkVorSteuern  = fEkpreis + fFixkosten + fGewinn;
     fSteuern       = fVkVorSteuern * STEUERFAKTOR;
     fVerkaufspreis = fVkVorSteuern + fSteuern;
   }
   else
   {
     fFixkosten     = fEkpreis * 0.35;
     fGewinn        = fEkpreis * (fGewinnProzent / 100);
     fVkVorSteuern  = fEkpreis + fFixkosten + fGewinn;
     fSteuern       = fVkVorSteuern * STEUERFAKTOR;
     fVerkaufspreis = fVkVorSteuern + fSteuern;
   }

   sprintf (sBuffer, "%.2lf", fFixkosten);
   St_FixkostenValue->Caption = sBuffer;

   sprintf (sBuffer, "%.2lf", fGewinn);
   St_GewinnValue->Caption = sBuffer;

   sprintf (sBuffer, "%.2lf", fVkVorSteuern);
   St_VkVorSteuernValue->Caption = sBuffer;

   sprintf (sBuffer, "%.2lf", fSteuern);
   St_SteuernValue->Caption = sBuffer;

   sprintf (sBuffer, "%.2lf", fVerkaufspreis);
   St_VkPreisValue->Caption = sBuffer;
}

//---------------------------------------------------------------------------
// bei jede nderung des Editfeldes E_EkPreis wird diese Funktion aufgerufen
//---------------------------------------------------------------------------
void __fastcall TVKRechnung::E_EkPreisChange(TObject *Sender)
{
   MyBerechnen ();
}

//---------------------------------------------------------------------------
// bei jeder nderung des Editfeldes E_Gewinn wird diese Funktion aufgerufen
//---------------------------------------------------------------------------void __fastcall TVKRechnung::B_CloseClick(TObject *Sender)
void __fastcall TVKRechnung::E_GewinnProzentChange(TObject *Sender)
{
   MyBerechnen ();
}

//---------------------------------------------------------------------------
// bei Bettigung der Checkbox wird diese Funktion aufgerufen
//---------------------------------------------------------------------------
void __fastcall TVKRechnung::Ck_SonderangebotClick(TObject *Sender)
{
   if (Ck_Sonderangebot->State == cbUnchecked)
   {
     Cb_GewinnProzent->Enabled = true;
   }
   else
   {
     //Cb_GewinnProzent->ItemIndex = 0;
     Cb_GewinnProzent->ItemIndex = Cb_GewinnProzent->Items->IndexOf("10 %");

     Cb_GewinnProzent->Enabled = false;
   }
   MyBerechnen();
}

//---------------------------------------------------------------------------
// bei jeder nderung der ComboboxAuswahl wird diese Funktion aufgerufen
//---------------------------------------------------------------------------void __fastcall TVKRechnung::B_CloseClick(TObject *Sender)
void __fastcall TVKRechnung::Cb_GewinnProzentChange(TObject *Sender)
{
   MyBerechnen ();
}

//---------------------------------------------------------------------------
// bei Bettigung des Buttons E_Gewinn wird diese Funktion aufgerufen
//---------------------------------------------------------------------------
void __fastcall TVKRechnung::B_CloseClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------





